"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.generate = void 0;
var typescript_1 = __importDefault(require("typescript"));
var swagger_parser_1 = __importDefault(require("@apidevtools/swagger-parser"));
var print_1 = require("./print");
var imports_1 = require("./imports");
var queryIds_1 = require("./queryIds");
var requests_1 = require("./requests");
var queries_1 = require("./queries");
var initialize_1 = require("./initialize");
var mutations_1 = require("./mutations");
var types_1 = require("./types");
var rapini_mutation_1 = require("./rapini-mutation");
var config_1 = require("./config");
function isOpenApiV3Document(doc) {
    return "openapi" in doc;
}
function parse(doc, $refs, options) {
    if (isOpenApiV3Document(doc)) {
        return parseOpenApiV3Doc(doc, $refs, options);
    }
    throw "OpenAPI Document version not supported";
}
function parseOpenApiV3Doc(doc, $refs, options) {
    return {
        imports: (0, imports_1.makeImports)(options),
        queryIds: (0, queryIds_1.makeQueryIds)(doc.paths),
        requests: (0, requests_1.makeRequests)(doc.paths, $refs, options),
        queries: (0, queries_1.makeQueries)(doc.paths, $refs),
        mutations: (0, mutations_1.makeMutations)(doc.paths, $refs),
        types: (0, types_1.makeTypes)(doc)
    };
}
function makeSourceFile(data) {
    return typescript_1["default"].factory.createSourceFile(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], __read(data.imports), false), __read(data.types), false), __read((0, config_1.makeConfigTypes)()), false), [
        (0, initialize_1.makeInitialize)(),
        (0, rapini_mutation_1.makeRapiniMutation)()
    ], false), __read(data.queryIds), false), [
        data.requests,
        data.queries
    ], false), __read(data.mutations), false), 
    /*endOfFileToken*/ typescript_1["default"].factory.createToken(typescript_1["default"].SyntaxKind.EndOfFileToken), 
    /*flags*/ typescript_1["default"].NodeFlags.None);
}
function makeSource(data) {
    var resultFile = typescript_1["default"].createSourceFile("client.ts", "", typescript_1["default"].ScriptTarget.Latest, 
    /*setParentNodes*/ false, typescript_1["default"].ScriptKind.TS);
    var printer = typescript_1["default"].createPrinter({ newLine: typescript_1["default"].NewLineKind.LineFeed });
    var result = printer.printNode(typescript_1["default"].EmitHint.Unspecified, makeSourceFile(data), resultFile);
    return result;
}
function generate(options) {
    return __awaiter(this, void 0, void 0, function () {
        var parser, api, data, source;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    parser = new swagger_parser_1["default"]();
                    return [4 /*yield*/, parser.bundle(options.path)];
                case 1:
                    api = _a.sent();
                    console.log("API name: %s, Version: %s", api.info.title, api.info.version);
                    data = parse(api, parser.$refs, options);
                    source = makeSource(data);
                    (0, print_1.print)(source, options);
                    return [2 /*return*/];
            }
        });
    });
}
exports.generate = generate;
