"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.print = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
function printGeneratedTS(result, options) {
    fs_1["default"].writeFileSync(path_1["default"].join(options.outputDir, "index.ts"), result);
}
function printPackageJson(options) {
    var pkgJson = "\n  {\n    \"name\": \"".concat(options.name, "\",\n    \"version\": \"").concat(options.packageVersion, "\",\n    \"description\": \"This package was generated by Rapini\",\n    \"main\": \"dist/index.js\",\n    \"types\": \"dist/index.d.ts\",\n    \"license\": \"private\",\n    \"scripts\": {\n      \"build\": \"tsc index.ts --declaration --skipLibCheck --outDir dist\"\n    },\n    \"peerDependencies\": {\n      \"axios\": \"0.27.x\",\n      ").concat(options.reactQueryV4
        ? "\"@tanstack/react-query\": \"4.x.x\""
        : "\"react-query\": \"3.x.x\"", "\n    },\n    \"devDependencies\": {\n      \"@types/node\": \"^17.0.34\",\n      \"typescript\": \"^4.6.4\"\n    }\n  }\n  ");
    fs_1["default"].writeFileSync(path_1["default"].join(options.outputDir, "package.json"), pkgJson);
}
function print(result, options) {
    if (!fs_1["default"].existsSync(options.outputDir)) {
        fs_1["default"].mkdirSync(options.outputDir);
    }
    printGeneratedTS(result, options);
    printPackageJson(options);
}
exports.print = print;
