"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.print = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
function printGeneratedTS(result, options) {
    fs_1["default"].writeFileSync(path_1["default"].join(options.outputDir, "index.ts"), result);
}
function printPackageJson(options) {
    var pkgJson = "\n  {\n    \"name\": \"".concat(options.name, "\",\n    \"version\": \"").concat(options.packageVersion, "\",\n    \"description\": \"This package was generated by Rapini\",\n    \"module\": \"dist-esm/index.js\",\n    \"main\": \"dist/index.js\",\n    \"types\": \"dist/index.d.ts\",\n    \"license\": \"private\",\n    \"scripts\": {\n      \"build\": \"npm run build-cjs && npm run build-esm\",\n      \"build-cjs\": \"tsc index.ts --declaration --skipLibCheck --outDir dist\",\n      \"build-esm\": \"tsc index.ts --skipLibCheck --moduleResolution node --target es2015 --esModuleInterop --outDir dist-esm\"\n    },\n    \"peerDependencies\": {\n      \"axios\": \"0.27.x\",\n      \"swr\": \"^1.3.0\"\n    },\n    \"devDependencies\": {\n      \"@types/node\": \"^17.0.34\",\n      \"typescript\": \"^4.6.4\"\n    }\n  }\n  ");
    fs_1["default"].writeFileSync(path_1["default"].join(options.outputDir, "package.json"), pkgJson);
}
function print(result, options) {
    if (!fs_1["default"].existsSync(options.outputDir)) {
        fs_1["default"].mkdirSync(options.outputDir);
    }
    printGeneratedTS(result, options);
    printPackageJson(options);
}
exports.print = print;
